=== debian/changelog ===
mcrl2 (201103-1) unstable; urgency=low

  * New upstream release (closes: #615678).
  * Upload to unstable.
  * debian/patches:
    - Added fix_manpage_generation.patch to fix macro errors in
      some man pages (fix from rev. 9060).
  * debian/rules:
    - Do man-page generation the right way (enabled MCRL2_MAN_PAGES).
  * debian/watch: 
    - Changed the .bz2 suffix into .gz. 

 -- Paul van Tilburg <paulvt@debian.org>  Fri, 25 Mar 2011 09:19:56 +0100

mcrl2 (201103~rc1-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * debian/control:
    - Remove unneeded build dependencies of some boost libraries.
    - Lower required version of boost libraries to 1.37.
  * debian/rules:
    - Remove build flags because they were changed upstream.
 -- Jeroen Keiren <jkeiren@win.tue.nl>  Fri, 11 Mar 2011 07:51:00 +0100
